/**
 * Copyright: Copyright (c) 2009 Jacob Carlborg.
 * Authors: Jacob Carlborg
 * Version: Initial created: Aug 1, 2009 
 * License: $(LINK2 http://www.boost.org/LICENSE_1_0.txt, Boost Software License 1.0)
 */
module dstep.applicationservices.coregraphics.CGColor;

import dstep.applicationservices.coregraphics.CGBase;
import dstep.applicationservices.coregraphics.CGColorSpace;
import dstep.applicationservices.coregraphics.CGPattern;
import dstep.corefoundation.CFBase;

struct CGColor;

alias CGColor* CGColorRef;

extern (C)
{
	extern
	{
		const CFStringRef kCGColorWhite;
		const CFStringRef kCGColorBlack;
		const CFStringRef kCGColorClear;
	}
}

extern (C)
{
	CGColorRef CGColorCreate (CGColorSpaceRef space, CGFloat* components);
	CGColorRef CGColorCreateGenericGray (CGFloat gray, CGFloat alpha);
	CGColorRef CGColorCreateGenericRGB (CGFloat red, CGFloat green, CGFloat blue, CGFloat alpha);
	CGColorRef CGColorCreateGenericCMYK (CGFloat cyan, CGFloat magenta, CGFloat yellow, CGFloat black, CGFloat alpha);
	CGColorRef CGColorGetConstantColor (CFStringRef colorName);
	CGColorRef CGColorCreateWithPattern (CGColorSpaceRef space, CGPatternRef pattern, CGFloat* components);
	CGColorRef CGColorCreateCopy (CGColorRef color);
	CGColorRef CGColorCreateCopyWithAlpha (CGColorRef color, CGFloat alpha);
	CGColorRef CGColorRetain (CGColorRef color);
	void CGColorRelease (CGColorRef color);
	bool CGColorEqualToColor (CGColorRef color1, CGColorRef color2);
	uint CGColorGetNumberOfComponents (CGColorRef color);
	CGFloat* CGColorGetComponents (CGColorRef color);
	CGFloat CGColorGetAlpha (CGColorRef color);
	CGColorSpaceRef CGColorGetColorSpace (CGColorRef color);
	CGPatternRef CGColorGetPattern (CGColorRef color);
	uint CGColorGetTypeID ();
}