/**
 * Copyright: Copyright (c) 2009 Jacob Carlborg.
 * Authors: Jacob Carlborg
 * Version: Initial created: Aug 3, 2009 
 * License: $(LINK2 http://www.boost.org/LICENSE_1_0.txt, Boost Software License 1.0)
 */
module dstep.foundation.NSValueTransformer;

import dstep.foundation.NSArray;
import dstep.foundation.NSObject;
import dstep.foundation.NSString;
import dstep.objc.bridge.Bridge;
import dstep.objc.objc;



import bindings = dstep.foundation.NSValueTransformer_bindings;

private
{
	NSString NSNegateBooleanTransformerName_;
	NSString NSIsNilTransformerName_;
	NSString NSIsNotNilTransformerName_;
	NSString NSUnarchiveFromDataTransformerName_;
	NSString NSKeyedUnarchiveFromDataTransformerName_;
}

NSString NSNegateBooleanTransformerName ()
{
	if (NSNegateBooleanTransformerName_)
		return NSNegateBooleanTransformerName_;
		
	return NSNegateBooleanTransformerName_ = new NSString(bindings.NSNegateBooleanTransformerName);
}

NSString NSIsNilTransformerName ()
{
	if (NSIsNilTransformerName_)
		return NSIsNilTransformerName_;
		
	return NSIsNilTransformerName_ = new NSString(bindings.NSIsNilTransformerName);
}

NSString NSIsNotNilTransformerName ()
{
	if (NSIsNotNilTransformerName_)
		return NSIsNotNilTransformerName_;
		
	return NSIsNotNilTransformerName_ = new NSString(bindings.NSIsNotNilTransformerName);
}

NSString NSUnarchiveFromDataTransformerName ()
{
	if (NSUnarchiveFromDataTransformerName_)
		return NSUnarchiveFromDataTransformerName_;
		
	return NSUnarchiveFromDataTransformerName_ = new NSString(bindings.NSUnarchiveFromDataTransformerName);
}

NSString NSKeyedUnarchiveFromDataTransformerName ()
{
	if (NSKeyedUnarchiveFromDataTransformerName_)
		return NSKeyedUnarchiveFromDataTransformerName_;
		
	return NSKeyedUnarchiveFromDataTransformerName_ = new NSString(bindings.NSKeyedUnarchiveFromDataTransformerName);
}

class NSValueTransformer : NSObject
{
	mixin (ObjcWrap);
	
	this ()
	{
		super(typeof(this).alloc.init.objcObject);
	}
	
	typeof(this) init ()
	{
		return invokeObjcSelf!(typeof(this), "init");
	}
	
	static void setValueTransformer (NSValueTransformer transformer, NSString name)
	{
		return invokeObjcSuperClass!(void, "setValueTransformer:forName:", NSValueTransformer, NSString)(transformer, name);
	}

	static NSValueTransformer valueTransformerForName (NSString name)
	{
		return invokeObjcSuperClass!(NSValueTransformer, "valueTransformerForName:", NSString)(name);
	}

	static NSArray valueTransformerNames ()
	{
		return invokeObjcSuperClass!(NSArray, "valueTransformerNames");
	}

	static Class transformedValueClass ()
	{
		return invokeObjcSuperClass!(Class, "transformedValueClass");
	}

	static bool allowsReverseTransformation ()
	{
		return invokeObjcSuperClass!(bool, "allowsReverseTransformation");
	}

	Object transformedValue (Object value)
	{
		return invokeObjcSelf!(Object, "transformedValue:", Object)(value);
	}

	Object reverseTransformedValue (Object value)
	{
		return invokeObjcSelf!(Object, "reverseTransformedValue:", Object)(value);
	}
}

