/**
 * Copyright: Copyright (c) 2009 Jacob Carlborg.
 * Authors: Jacob Carlborg
 * Version: Initial created: Sep 28, 2009 
 * License: $(LINK2 http://www.boost.org/LICENSE_1_0.txt, Boost Software License 1.0)
 */
module dstep.qtkit.QTCaptureAudioPreviewOutput;

import dstep.foundation.Foundation;
import dstep.objc.bridge.Bridge;
import dstep.objc.objc;
import dstep.qtkit.QTCaptureOutput;
import dstep.qtkit.QTKitDefines;

class QTCaptureAudioPreviewOutput : QTCaptureOutput
{
	mixin (ObjcWrap);

	NSString outputDeviceUniqueID ()
	{
		return invokeObjcSelf!(NSString, "outputDeviceUniqueID");
	}

	void setOutputDeviceUniqueID (NSString uniqueID)
	{
		return invokeObjcSelf!(void, "setOutputDeviceUniqueID:", NSString)(uniqueID);
	}

	float volume ()
	{
		return invokeObjcSelf!(float, "volume");
	}

	void setVolume (float volume)
	{
		return invokeObjcSelf!(void, "setVolume:", float)(volume);
	}
}

