/**
 * Copyright: Copyright (c) 2009 Jacob Carlborg.
 * Authors: Jacob Carlborg
 * Version: Initial created: Sep 28, 2009 
 * License: $(LINK2 http://www.boost.org/LICENSE_1_0.txt, Boost Software License 1.0)
 */
module dstep.qtkit.QTCompressionOptions;

import dstep.foundation.Foundation;
import dstep.objc.bridge.Bridge;
import dstep.objc.objc;
import dstep.qtkit.QTKitDefines;

class QTCompressionOptions : NSObject
{
	mixin (ObjcWrap);

	static NSArray compressionOptionsIdentifiersForMediaType (NSString mediaType)
	{
		return invokeObjcSelfClass!(NSArray, "compressionOptionsIdentifiersForMediaType:", NSString)(mediaType);
	}

	static Object compressionOptionsWithIdentifier (NSString identifier)
	{
		return invokeObjcSelfClass!(Object, "compressionOptionsWithIdentifier:", NSString)(identifier);
	}

	NSString mediaType ()
	{
		return invokeObjcSelf!(NSString, "mediaType");
	}

	NSString localizedDisplayName ()
	{
		return invokeObjcSelf!(NSString, "localizedDisplayName");
	}

	NSString localizedCompressionOptionsSummary ()
	{
		return invokeObjcSelf!(NSString, "localizedCompressionOptionsSummary");
	}

	bool isEqualToCompressionOptions (QTCompressionOptions compressionOptions)
	{
		return invokeObjcSelf!(bool, "isEqualToCompressionOptions:", QTCompressionOptions)(compressionOptions);
	}
}

