/**
 * Copyright: Copyright (c) 2009 Jacob Carlborg.
 * Authors: Jacob Carlborg
 * Version: Initial created: Sep 24, 2009 
 * License: $(LINK2 http://www.boost.org/LICENSE_1_0.txt, Boost Software License 1.0)
 */
module dstep.quartzcore.CAMediaTiming;

import dstep.corefoundation.CFDate;
import dstep.foundation.NSString;
import dstep.objc.bridge.Bridge;
import dstep.objc.objc;
import dstep.quartzcore.CABase;

import bindings = dstep.quartzcore.CAMediaTiming_bindings;

private
{
	NSString kCAFillModeForwards_;
	NSString kCAFillModeBackwards_;
	NSString kCAFillModeBoth_;
	NSString kCAFillModeRemoved_;
}

NSString kCAFillModeForwards ()
{
	if (kCAFillModeForwards_)
		return kCAFillModeForwards_;

	return kCAFillModeForwards_ = new NSString(bindings.kCAFillModeForwards);
}

NSString kCAFillModeBackwards ()
{
	if (kCAFillModeBackwards_)
		return kCAFillModeBackwards_;

	return kCAFillModeBackwards_ = new NSString(bindings.kCAFillModeBackwards);
}

NSString kCAFillModeBoth ()
{
	if (kCAFillModeBoth_)
		return kCAFillModeBoth_;

	return kCAFillModeBoth_ = new NSString(bindings.kCAFillModeBoth);
}

NSString kCAFillModeRemoved ()
{
	if (kCAFillModeRemoved_)
		return kCAFillModeRemoved_;

	return kCAFillModeRemoved_ = new NSString(bindings.kCAFillModeRemoved);
}

interface ICAMediaTiming
{
	CFTimeInterval beginTime ();
	void beginTime (CFTimeInterval time);
	alias beginTime setBeginTime;
	
	CFTimeInterval duration ();
	void duration (CFTimeInterval time);
	alias duration setDuration;
	
	float speed ();
	void speed (float f);
	alias speed setSpeed;
	
	CFTimeInterval timeOffset ();
	void timeOffset (CFTimeInterval time);
	alias timeOffset setTimeOffset;
	
	float repeatCount ();
	void repeatCount (float count);
	alias repeatCount setRepeatCount;
	
	CFTimeInterval repeatDuration ();
	void repeatDuration (CFTimeInterval time);
	alias repeatDuration setRepeatCount;
	
	NSString fillMode ();
	void fillMode (NSString mode);
	alias fillMode setFillMode;
}
