/**
 * Copyright: Copyright (c) 2009 Jacob Carlborg.
 * Authors: Jacob Carlborg
 * Version: Initial created: Sep 24, 2009 
 * License: $(LINK2 http://www.boost.org/LICENSE_1_0.txt, Boost Software License 1.0)
 */
module dstep.quartzcore.CARenderer;

import dstep.applicationservices.coregraphics.CGGeometry;
import dstep.foundation.NSDictionary;
import dstep.foundation.NSObject;
import dstep.objc.bridge.Bridge;
import dstep.objc.objc;
import dstep.quartzcore.CABase;
import dstep.quartzcore.CALayer;
import dstep.quartzcore.CIContext;
import dstep.quartzcore.CVBase;

class CARenderer : NSObject
{
	mixin (ObjcWrap);

	static CARenderer rendererWithCGLContext (void* ctx, NSDictionary dict)
	{
		return invokeObjcSelfClass!(CARenderer, "rendererWithCGLContext:options:", void*, NSDictionary)(ctx, dict);
	}

	CGRect bounds ()
	{
		return invokeObjcSelf!(CGRect, "bounds");
	}

	void setBounds (CGRect arg0)
	{
		return invokeObjcSelf!(void, "setBounds:", CGRect)(arg0);
	}
	
	alias setBounds bounds;

	void beginFrameAtTime (double t, CVTimeStamp* ts)
	{
		return invokeObjcSelf!(void, "beginFrameAtTime:timeStamp:", double, CVTimeStamp*)(t, ts);
	}

	CGRect updateBounds ()
	{
		return invokeObjcSelf!(CGRect, "updateBounds");
	}

	void addUpdateRect (CGRect r)
	{
		return invokeObjcSelf!(void, "addUpdateRect:", CGRect)(r);
	}

	void render ()
	{
		return invokeObjcSelf!(void, "render");
	}

	double nextFrameTime ()
	{
		return invokeObjcSelf!(double, "nextFrameTime");
	}

	void endFrame ()
	{
		return invokeObjcSelf!(void, "endFrame");
	}
}

