/**
 * Copyright: Copyright (c) 2009 Jacob Carlborg.
 * Authors: Jacob Carlborg
 * Version: Initial created: Sep 24, 2009 
 * License: $(LINK2 http://www.boost.org/LICENSE_1_0.txt, Boost Software License 1.0)
 */
module dstep.quartzcore.CATextLayer;

import dstep.foundation.NSString;
import dstep.objc.bridge.Bridge;
import dstep.objc.objc;
import dstep.quartzcore.CALayer;

import bindings = dstep.quartzcore.CATextLayer_bindings;

private
{
	NSString kCATruncationNone_;
	NSString kCATruncationStart_;
	NSString kCATruncationEnd_;
	NSString kCATruncationMiddle_;
	NSString kCAAlignmentNatural_;
	NSString kCAAlignmentLeft_;
	NSString kCAAlignmentRight_;
	NSString kCAAlignmentCenter_;
	NSString kCAAlignmentJustified_;
}

NSString kCATruncationNone ()
{
	if (kCATruncationNone_)
		return kCATruncationNone_;

	return kCATruncationNone_ = new NSString(bindings.kCATruncationNone);
}

NSString kCATruncationStart ()
{
	if (kCATruncationStart_)
		return kCATruncationStart_;

	return kCATruncationStart_ = new NSString(bindings.kCATruncationStart);
}

NSString kCATruncationEnd ()
{
	if (kCATruncationEnd_)
		return kCATruncationEnd_;

	return kCATruncationEnd_ = new NSString(bindings.kCATruncationEnd);
}

NSString kCATruncationMiddle ()
{
	if (kCATruncationMiddle_)
		return kCATruncationMiddle_;

	return kCATruncationMiddle_ = new NSString(bindings.kCATruncationMiddle);
}

NSString kCAAlignmentNatural ()
{
	if (kCAAlignmentNatural_)
		return kCAAlignmentNatural_;

	return kCAAlignmentNatural_ = new NSString(bindings.kCAAlignmentNatural);
}

NSString kCAAlignmentLeft ()
{
	if (kCAAlignmentLeft_)
		return kCAAlignmentLeft_;

	return kCAAlignmentLeft_ = new NSString(bindings.kCAAlignmentLeft);
}

NSString kCAAlignmentRight ()
{
	if (kCAAlignmentRight_)
		return kCAAlignmentRight_;

	return kCAAlignmentRight_ = new NSString(bindings.kCAAlignmentRight);
}

NSString kCAAlignmentCenter ()
{
	if (kCAAlignmentCenter_)
		return kCAAlignmentCenter_;

	return kCAAlignmentCenter_ = new NSString(bindings.kCAAlignmentCenter);
}

NSString kCAAlignmentJustified ()
{
	if (kCAAlignmentJustified_)
		return kCAAlignmentJustified_;

	return kCAAlignmentJustified_ = new NSString(bindings.kCAAlignmentJustified);
}

