/**
 * Copyright: Copyright (c) 2009 Jacob Carlborg.
 * Authors: Jacob Carlborg
 * Version: Initial created: Jul 22, 2009 
 * License: $(LINK2 http://www.boost.org/LICENSE_1_0.txt, Boost Software License 1.0)
 */
module dstep.security.cssmcspi;

import dstep.security.cssmconfig;
import dstep.security.cssmspi;
import dstep.security.cssmtype;

struct CSSM_SPI_CSP_FUNCS
{
	uint Event;
	ulong CCHandle;
	CSSM_CONTEXT* Context;
	int Encrypt;
	uint QuerySizeCount;
	CSSM_DATA* DataBufs;
	uint DataBufCount;
	uint DigestAlgorithm;
	CSSM_DATA* ClearBufs;
	uint ClearBufCount;
	CSSM_DATA_PTR CipherBufs;
	uint CipherBufCount;
	CSSM_SIZE* bytesEncrypted;
	CSSM_DATA_PTR RemData;
	CSSM_SIZE* bytesDecrypted;
	CSSM_KEY* Key;
	uint KeyUsage;
	uint KeyAttr;
	CSSM_DATA* KeyLabel;
	CSSM_RESOURCE_CONTROL_CONTEXT* CredAndAclEntry;
	uint PublicKeyUsage;
	uint PublicKeyAttr;
	CSSM_DATA* PublicKeyLabel;
	CSSM_KEY_PTR PublicKey;
	uint PrivateKeyUsage;
	uint PrivateKeyAttr;
	CSSM_DATA* PrivateKeyLabel;
	CSSM_KEY_PTR PrivateKey;
	uint ParamBits;
	CSSM_DATA_PTR Param;
	uint32* NumberOfUpdatedAttibutes;
	CSSM_ACCESS_CREDENTIALS* AccessCred;
	CSSM_DATA* DescriptiveData;
	CSSM_WRAP_KEY_PTR WrappedKey;
	CSSM_KEY_PTR UnwrappedKey;
	CSSM_KEY_PTR KeyPtr;
	uint PassThroughId;
	void* InData;
	CSSM_DATA* LoginName;
	uint TimeAlgorithm;
	CSSM_STRING* SelectionTag;
	uint32* NumberOfAclInfos;
	CSSM_ACL_EDIT* AclEdit;
}

